import * as t from "io-ts";
import * as r from "@pagopa/ts-commons/lib/requests";
import { Notification } from "./Notification";
import { SuccessResponse } from "./SuccessResponse";
import { ProblemJson } from "./ProblemJson";
/****************************************************************
 * notify
 */
export type NotifyT = r.IPostApiRequestType<{
    readonly body: Notification;
}, "Content-Type", never, r.IResponseType<200, SuccessResponse, never> | r.IResponseType<400, ProblemJson, never> | r.IResponseType<401, undefined, never> | r.IResponseType<500, ProblemJson, never>>;
export declare const notifyDefaultResponses: {
    200: t.ExactC<t.IntersectionC<[t.TypeC<{}>, t.PartialC<{
        message: t.StringC;
    }>]>>;
    400: t.ExactC<t.IntersectionC<[t.TypeC<{}>, t.PartialC<{
        type: t.Type<string, any, unknown>;
        title: t.StringC;
        status: t.UnionC<[import("@pagopa/ts-commons/lib/types").Tagged<import("@pagopa/ts-commons/lib/numbers").IWithinRangeIntegerTag<100, 599>, number, number, unknown>, t.LiteralC<599>]>;
        detail: t.StringC;
        instance: t.StringC;
    }>]>>;
    401: t.UndefinedC;
    500: t.ExactC<t.IntersectionC<[t.TypeC<{}>, t.PartialC<{
        type: t.Type<string, any, unknown>;
        title: t.StringC;
        status: t.UnionC<[import("@pagopa/ts-commons/lib/types").Tagged<import("@pagopa/ts-commons/lib/numbers").IWithinRangeIntegerTag<100, 599>, number, number, unknown>, t.LiteralC<599>]>;
        detail: t.StringC;
        instance: t.StringC;
    }>]>>;
};
export type NotifyResponsesT<A0 = SuccessResponse, C0 = SuccessResponse, A1 = ProblemJson, C1 = ProblemJson, A2 = undefined, C2 = undefined, A3 = ProblemJson, C3 = ProblemJson> = {
    200: t.Type<A0, C0>;
    400: t.Type<A1, C1>;
    401: t.Type<A2, C2>;
    500: t.Type<A3, C3>;
};
export declare function notifyDecoder<A0 = SuccessResponse, C0 = SuccessResponse, A1 = ProblemJson, C1 = ProblemJson, A2 = undefined, C2 = undefined, A3 = ProblemJson, C3 = ProblemJson>(overrideTypes?: Partial<NotifyResponsesT<A0, C0, A1, C1, A2, C2, A3, C3>> | t.Type<A0, C0> | undefined): r.ResponseDecoder<r.IResponseType<200, A0, never> | r.IResponseType<400, A1, never> | r.IResponseType<401, A2, never> | r.IResponseType<500, A3, never>>;
export declare const notifyDefaultDecoder: () => r.ResponseDecoder<r.IResponseType<401, undefined, never> | r.IResponseType<200, {} & {
    message?: string | undefined;
}, never> | r.IResponseType<400, {} & {
    type?: string | undefined;
    title?: string | undefined;
    status?: 599 | (number & import("@pagopa/ts-commons/lib/numbers").IWithinRangeIntegerTag<100, 599>) | undefined;
    detail?: string | undefined;
    instance?: string | undefined;
}, never> | r.IResponseType<500, {} & {
    type?: string | undefined;
    title?: string | undefined;
    status?: 599 | (number & import("@pagopa/ts-commons/lib/numbers").IWithinRangeIntegerTag<100, 599>) | undefined;
    detail?: string | undefined;
    instance?: string | undefined;
}, never>>;
